package com.retmix.volga.storage.models;

import com.retmix.volga.shared.models.User;
import com.retmix.volga.storage.dto.DirDTO;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@Builder
@Entity
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "folders")
public class Directory {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String name;
    private boolean root;

    @ManyToOne
    @JoinColumn(name = "parent_id")
    private Directory directory;
    @ManyToOne
    @JoinColumn(name = "user_id")
    private User user;

    @OneToMany(mappedBy = "directory", cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private List<Directory> innerDirs;

    @OneToMany(mappedBy = "directory", cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private List<File> filesInDir;

    public DirDTO toDTO() {
        return DirDTO.builder()
                .id(id)
                .root(root)
                .name(name).build();
    }
}
