package com.retmix.volga.storage.models;

import com.retmix.volga.shared.models.User;
import com.retmix.volga.storage.dto.files.FileDTO;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Entity
@NoArgsConstructor
@AllArgsConstructor
@Builder
@Table(name = "files")
public class File {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String name;
    private String url;
    private boolean shared;
    private String password;

    @ManyToOne
    @JoinColumn(name = "folder_id")
    private Directory directory;

    @ManyToOne
    @JoinColumn(name = "user_id")
    private User user;

    public FileDTO toDTO() {
        return FileDTO.builder()
                .id(id)
                .name(name)
                .url(url)
                .shared(shared)
                .dirId(directory.getId()).build();
    }
}
