package com.retmix.volga.storage.services;

import com.retmix.volga.shared.handler.exceptions.ObjectNotFoundException;
import com.retmix.volga.shared.models.User;
import com.retmix.volga.shared.repositories.UserRepository;
import com.retmix.volga.storage.dto.DirDTO;
import com.retmix.volga.storage.models.Directory;
import com.retmix.volga.storage.repositories.DirectoryRepository;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

@Service
@AllArgsConstructor
public class AdminDirService {
    private final UserRepository userRepository;
    private final DirectoryRepository directoryRepository;

    public DirDTO getRoot(Long userId) {
        User user = userRepository.findById(userId).orElseThrow(() -> new ObjectNotFoundException("Not found"));
        return user.getDirsUser().stream().filter(Directory::isRoot).map(Directory::toDTO).toList().stream().findFirst()
                .get();
    }

    public DirDTO getById(Long id) {
        return directoryRepository.findById(id).orElseThrow(() -> new ObjectNotFoundException("Not found"))
                .toDTO();
    }

}
