package com.retmix.volga.storage.services;

import com.retmix.volga.shared.handler.exceptions.ObjectNotFoundException;
import com.retmix.volga.shared.handler.exceptions.PermissionException;
import com.retmix.volga.shared.models.User;
import com.retmix.volga.storage.dto.files.FileDTO;
import com.retmix.volga.storage.dto.files.GetFileDTO;
import com.retmix.volga.storage.models.File;
import com.retmix.volga.storage.repositories.DirectoryRepository;
import com.retmix.volga.storage.repositories.FileRepository;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@AllArgsConstructor
public class AdminFileService {
    private final FileRepository fileRepository;
    private final DirectoryRepository directoryRepository;

    public FileDTO getFileId(Long id) {
        return fileRepository.findById(id).orElseThrow(() -> new ObjectNotFoundException("Not found"))
                .toDTO();
    }

    public List<FileDTO> getFromDir(Long idDir) {
        return directoryRepository.findById(idDir).orElseThrow(() -> new ObjectNotFoundException("Not found"))
                .getFilesInDir().stream().map(File::toDTO).toList();
    }
}
